Bug 1226076

Summary: beakerd stuck on database when hostRequires contains <or> group specification
Product: [Community] Beaker Reporter: Amit Saha <asaha>
Component: schedulerAssignee: matt jia <mjia>
Status: CLOSED CURRENTRELEASE QA Contact: tools-bugs <tools-bugs>
Severity: unspecified Docs Contact:
Priority: unspecified    
Version: 20CC: aigao, alemay, asaha, chuhu, dcallagh, dowang, ebaak, emcnabb, mjia
Target Milestone: 20.2Keywords: NeedsTestCase, Patch
Target Release: ---   
Hardware: Unspecified   
OS: Unspecified   
Whiteboard:
Fixed In Version: Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2015-07-14 08:04:57 UTC Type: Bug
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: --- Target Upstream Version:

Description Amit Saha 2015-05-29 00:05:58 UTC
Description of problem:

The following specification in hostRequires:

<or>
	<group op="=" value="group2"/>
	<group op="=" value="group3"/>
</or>

results in a query to the DB which was seen in production to be waiting for close to 6 hours and then had to be killed for beakerd to proceed.



Version-Release number of selected component (if applicable):


How reproducible:

Always.


Steps to Reproduce:
1. Submit a recipe with the above in hostRequires
2. 
3.

Actual results:

beakerd stuck, no recipes are processed.

Expected results:


Additional info:

Comment 3 matt jia 2015-06-02 04:37:22 UTC
We have this problem before. See BZ1183239. The thing is System.pools.contains() should not be used with many-to-many relationships.

On Gerrit:

 http://gerrit.beaker-project.org/#/c/4230/

Comment 7 matt jia 2015-06-16 00:25:22 UTC
Steps to reproduce:
1. Submit a job containing <hostRequires/> like the example in comment 1.
2. Check that Beaker schedules the job in a reasonable amount of time and nothing blows up.

Comment 8 wangdong 2015-07-13 06:26:42 UTC
Verify passed on https://beaker-devel.app.eng.bos.redhat.com/

See below job:


https://beaker-devel.app.eng.bos.redhat.com/jobs/8166

Change status to verified.

Comment 9 Dan Callaghan 2015-07-14 08:04:57 UTC
Beaker 20.2 has been released.